/* 
 * File:   AcapelaCallback.h
 * Author: matt
 *
 * Created on July 13, 2011, 10:28 PM
 */

#ifndef ACAPELACALLBACK_H
#define	ACAPELACALLBACK_H

#include <stdlib.h>

#include "robokind/speech/acapela/audio.h"
#include "nscube.h"

namespace robokind{
  namespace acapela{
      
    class DataCallback {
        public:
            virtual int callback(const unsigned char* data, unsigned int len, PNSC_SOUND_DATA format,  void * user_data) = 0;

            static int _callback(const unsigned char* data, unsigned int len, PNSC_SOUND_DATA format,  void * user_data);
    };
    
    class EventCallback{
        public:
            virtual int callback(unsigned int eventId, unsigned int len, PNSC_EVENT_DATA eventData,  void * user_data) = 0;
        
            static int _callback(unsigned int eventId, unsigned int len, PNSC_EVENT_DATA eventData, void * user_data);
    };
    
    typedef struct{
        DataCallback* dataCallback;
        EventCallback* eventCallback;
        void* userData;
    } CallbackData;
    
}}
#endif	/* ACAPELACALLBACK_H */

