/* 
 * File:   AcapelaService.h
 * Author: matt
 *
 * Created on July 14, 2011, 9:08 PM
 */

#ifndef ACAPELASERVICE_H
#define	ACAPELASERVICE_H

#include "robokind/messaging/AQService.h"

#include <string.h>

#include "robokind/messaging/AQStream.h"
#include "robokind/messaging/AQReceiver.h"
#include "robokind/messaging/AQSender.h"
#include "robokind/speech/acapela/protocol/AcapelaTTSConfig.h"
#include "robokind/speech/acapela/AcapelaTTSProvider.h"
#include "robokind/speech/acapela/PortAudioProvider.h"

using namespace std;
using robokind::AQService;

namespace robokind{
  namespace acapela{

    class AcapelaService : AQService<AcapelaTTSConfig>{
        private:
            AcapelaTTSProvider* myTTSProvider;
            PortAudioProvider* myAudioOutput;
            string myVoiceName;
            AQStream* myStream;
            AQReceiver* myRequestReceiver;
            AQSender* myEventSender;

            void fetchAndRespond();

            void threadSafeWorker();
            bool _initialize(AcapelaTTSConfig* conf);
            bool _initialize(string voiceName, double sampleRate, AQReceiver* req, AQSender* evt);
            void close();
        public:
            void handleCommandMessage(Message &msg);    
    };
}}

#endif	/* ACAPELASERVICE_H */

