/* 
 * File:   AcapelaTTSEngine.h
 * Author: matt
 *
 * Single-Channel Single-Thread 
 * Created on July 12, 2011, 5:03 PM
 */

#ifndef ACAPELATTSENGINE_H
#define	ACAPELATTSENGINE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>

#include "robokind/speech/acapela/audio.h"
#include "nscube.h"
#include "robokind/speech/acapela/AcapelaCallback.h"

using namespace std;

namespace robokind{
  namespace acapela{

    class AcapelaTTSProvider{
        private:
            nscHSRV myServerContext;
            NSC_SRVINFO_DATA myServerInfo; 
            nscHANDLE myDispatchHandle;
            nscHANDLE myChannelHandle;
            nscCHANID myChannelId;
            NSC_EXEC_DATA myExecutionOptions;
            int myVoiceCount;
            NSC_FINDVOICE_DATA* myAvailableVoices;
            NSC_FINDVOICE_DATA* mySelectedVoice;
            string myServerAddress;

            int loadVoices();
        public:
            AcapelaTTSProvider(string address="127.0.0.1");
            bool startServer();
            
            void setDataCallback(DataCallback* cb);
            void setEventCallback(EventCallback* cb);
            void setUserCallbackData(void* data);

            const NSC_FINDVOICE_DATA* listAvailableVoices();
            bool initializeChannel(string voiceName);
            NSC_FINDVOICE_DATA* getSelectedVoiceInfo();

            bool addText(const char* textBuffer, int len, void* eventData);
            bool speak();
            bool speakText(const char* textBuffer, int len, void* eventData);
            bool speakText(string text, void* eventData=0);

            bool close();
    };
}}
#endif	/* ACAPELATTSENGINE_H */

