/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#ifndef ACAPELATTSCONFIG_H_2156568285__H_
#define ACAPELATTSCONFIG_H_2156568285__H_


#include <boost/any.hpp>
#include <avro/Specific.hh>
#include <avro/Encoder.hh>
#include <avro/Decoder.hh>
struct AcapelaTTSConfig {
    std::string brokerAddress;
    std::string connectOptions;
    std::string requestQueue;
    std::string eventQueue;
    std::string voiceName;
    double sampleRate;
};

namespace avro {
template<> struct codec_traits<AcapelaTTSConfig> {
    static void encode(Encoder& e, const AcapelaTTSConfig& v) {
        avro::encode(e, v.brokerAddress);
        avro::encode(e, v.connectOptions);
        avro::encode(e, v.requestQueue);
        avro::encode(e, v.eventQueue);
        avro::encode(e, v.voiceName);
        avro::encode(e, v.sampleRate);
    }
    static void decode(Decoder& d, AcapelaTTSConfig& v) {
        avro::decode(d, v.brokerAddress);
        avro::decode(d, v.connectOptions);
        avro::decode(d, v.requestQueue);
        avro::decode(d, v.eventQueue);
        avro::decode(d, v.voiceName);
        avro::decode(d, v.sampleRate);
    }
};

}
#endif
