/* 
 * File:   CameraService.h
 * Author: matt
 *
 * Created on July 15, 2011, 4:17 AM
 */

#ifndef CAMERASERVICE_H
#define	CAMERASERVICE_H

#include <string.h>
#include <opencv/cv.h>
#include <opencv/cxcore.h>
#include <opencv/highgui.h>
#include "robokind/messaging/AQStream.h"
#include "robokind/messaging/AQReceiver.h"
#include "robokind/messaging/AQSender.h"
#include "robokind/messaging/AQService.h"
#include "robokind/vision/imageUtils.h"
#include "robokind/vision/protocol/ImageRecord.h"
#include "robokind/vision/camera/protocol/CameraConfig.h"

namespace robokind{
    class CameraService : public AQService<CameraConfig> {
        private:
            AQSender* myVideoSender;
            int myDevice;
            int myFrameLength;
            CvCapture* myCapture;

            bool myConvertColorFlag;
            IplImage *myConvertColorHeader;
            bool myResizeFlag;
            IplImage *myResizeHeader;
            
            
            void threadSafeWorker();
            bool _initialize(CameraConfig* conf);
            void close();
        public:
            void handleCommandMessage(Message &msg);
            int getFrameLength();
            void setFrameLength(int len);    
    };
}

#endif	/* CAMERASERVICE_H */

