#include "robokind/messaging/AQStream.h"
using namespace robokind;

AQStream::AQStream(const char* broker, const char* options){
    myBrokerAddress = new char[BROKER_LEN];
    myConnectionOptions = new char[OPTIONS_LEN];
    strncpy(myBrokerAddress,broker,BROKER_LEN-1);
    strncpy(myConnectionOptions,options,OPTIONS_LEN-1);
}

char* AQStream::getBrokerAddress(){
    return myBrokerAddress;
}

void AQStream::setBrokerAddress(const char* address){
    strncpy(myBrokerAddress,address,BROKER_LEN-1);
}

char* AQStream::getConnectionOptions(){
    return myConnectionOptions;
}

void AQStream::setConnectionOptions(const char* options){
    strncpy(myConnectionOptions,options,OPTIONS_LEN-1);
}

bool AQStream::connect(){
    myConnection = new Connection(myBrokerAddress, myConnectionOptions);
    try {
        myConnection->open();
        //if(!myConnection->isOpen()){
        //    return false;
        //}
        mySession = myConnection->createSession();
        return true;
    } catch(const exception& error) {
        return false;
    } catch(...){
        return false;
    }
}

void AQStream::disconnect(){
	if(myConnection->isOpen()){
		myConnection->close();
	}
}

AQReceiver* AQStream::createReceiver(const char* destination){
    return new AQReceiver(&mySession,destination);
}

AQSender* AQStream::createSender(const char* destination){
    return new AQSender(&mySession, destination);
}

AQDrain* AQStream::createDrain(const char* destination){
    return new AQDrain(&mySession, destination);
}